/**
 * 
 */
package com.hengtian.simplechat;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;

/**
 * @author notifier
 * @create 2010-9-25 04:42:48
 * @version 1.0
 */
public class SimpleChatClient
{
	private JTextArea incoming;

	private JTextField outgoing;

	private BufferedReader reader;

	private PrintWriter writer;

	private Socket socket;

	public static void main(String[] args)
	{
		SimpleChatClient client = new SimpleChatClient();
		client.startUp();
	}

	/**
	 * ͻ˵,Ĺ:
	 * 1. ʼ
	 * 2. ˷Ϣ
	 * 3. ӷ˶ȡϢ,ӡ.
	 */
	public void startUp()
	{
		// µGUI
		JFrame frame = new JFrame("򵥵ͻ");
        JPanel mainPanel = new JPanel();
        
        incoming = new JTextArea(15,20); 
        incoming.setLineWrap(true);
        incoming.setWrapStyleWord(true);
        incoming.setEditable(false);
       
        JScrollPane qScroller = new JScrollPane(incoming);
        qScroller.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        qScroller.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        

        outgoing = new JTextField(20);
        

        JButton sendButton = new JButton("");
        // עһactionListener,Ϣ
        sendButton.addActionListener(new SendButtonListener());

        
        mainPanel.add(qScroller);
        mainPanel.add(outgoing);
        mainPanel.add(sendButton);
        
        // ʼϢ
        setupNetwork();
        
        // յϢ
        Thread readerThread = new Thread(new IncomingReader());
        readerThread.start();
          
        frame.getContentPane().add(BorderLayout.CENTER, mainPanel);
        frame.setSize(400,500);
        frame.setVisible(true);
	}

	private void setupNetwork()
	{
		try
		{
			// ʼ: socket,ȡsocket
			socket = new Socket("127.0.0.1", 5000);
			
			InputStreamReader stream = new InputStreamReader(socket.getInputStream());
			reader = new BufferedReader(stream);
			
			writer = new PrintWriter(socket.getOutputStream());
			
			System.out.println("ʼѾ,!");
		} catch (UnknownHostException e)
		{
			e.printStackTrace();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	public class SendButtonListener implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			try
			{
				// socketдϢ
				writer.println(outgoing.getText());
				writer.flush();
			} catch (Exception ex)
			{
				ex.printStackTrace();
			} finally 
			{
				// ر
				writer.close();
			}
			//
			outgoing.setText("");
			outgoing.requestFocus();
		}
	}

	public class IncomingReader implements Runnable
	{
		public void run()
		{
			String message;
			try
			{
				// socketжȡϢ
				while ((message = reader.readLine()) != null)
				{
					System.out.println("The message received is " + message);
					incoming.append(message + "\n");
				}
			} catch (IOException e)
			{
				e.printStackTrace();
			}
			finally
			{
				try
				{
					// ر
					reader.close();
				} catch (IOException e)
				{
					e.printStackTrace();
				}
			}
		}
	}
}
